package b4a.ex2_HC06_leds;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.ex2_HC06_leds", "b4a.ex2_HC06_leds.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.ex2_HC06_leds", "b4a.ex2_HC06_leds.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static boolean _n = false;
public static boolean _ne = false;
public static boolean _e = false;
public static boolean _se = false;
public static boolean _s = false;
public static boolean _sw = false;
public static boolean _w = false;
public static boolean _nw = false;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.objects.streams.File.TextReaderWrapper _textreader1 = null;
public static anywheresoftware.b4a.objects.streams.File.TextWriterWrapper _textwriter1 = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static boolean _connected = false;
public anywheresoftware.b4a.objects.LabelWrapper _lbln = null;
public anywheresoftware.b4a.objects.LabelWrapper _lble = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblne = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblnw = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbls = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblse = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblsw = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblw = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtlog = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblreset = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 51;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 54;BA.debugLine="Activity.LoadLayout(\"main\")";
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 //BA.debugLineNum = 56;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 57;BA.debugLine="Serial1.Initialize(\"Serial1\")			'initialize the serial port";
_serial1.Initialize("Serial1");
 //BA.debugLineNum = 58;BA.debugLine="Timer1.Initialize(\"Timer1\", 200)		'initialize Timer1 to create an event every 200ms";
_timer1.Initialize(processBA,"Timer1",(long)(200));
 };
 //BA.debugLineNum = 60;BA.debugLine="Activity.AddMenuItem(\"Connect\", \"mnuConnect\")";
mostCurrent._activity.AddMenuItem("Connect","mnuConnect");
 //BA.debugLineNum = 61;BA.debugLine="Activity.AddMenuItem(\"Disconnect\", \"mnuDisconnect\")";
mostCurrent._activity.AddMenuItem("Disconnect","mnuDisconnect");
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 72;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 65;BA.debugLine="If Serial1.IsEnabled = False Then";
if (_serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 66;BA.debugLine="Msgbox(\"Please enable Bluetooth.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Please enable Bluetooth.","",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 68;BA.debugLine="Serial1.Listen 							'listen for incoming connections";
_serial1.Listen(processBA);
 };
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 39;BA.debugLine="Dim lblN As Label";
mostCurrent._lbln = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim lblE As Label";
mostCurrent._lble = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Dim lblNE As Label";
mostCurrent._lblne = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Dim lblNW As Label";
mostCurrent._lblnw = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Dim lblS As Label";
mostCurrent._lbls = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim lblSE As Label";
mostCurrent._lblse = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Dim lblSW As Label";
mostCurrent._lblsw = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim lblW As Label";
mostCurrent._lblw = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim txtLog As EditText";
mostCurrent._txtlog = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim lblReset As Label";
mostCurrent._lblreset = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _lble_click() throws Exception{
 //BA.debugLineNum = 218;BA.debugLine="Sub lblE_Click";
 //BA.debugLineNum = 219;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 220;BA.debugLine="If E Then";
if (_e) { 
 //BA.debugLineNum = 221;BA.debugLine="E = False";
_e = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 222;BA.debugLine="lblE.Color = Colors.Gray";
mostCurrent._lble.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 223;BA.debugLine="TextWriter1.WriteLine(\"F\")";
_textwriter1.WriteLine("F");
 }else {
 //BA.debugLineNum = 225;BA.debugLine="E = True";
_e = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 226;BA.debugLine="lblE.Color = Colors.Green";
mostCurrent._lble.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 227;BA.debugLine="TextWriter1.WriteLine(\"E\")";
_textwriter1.WriteLine("E");
 };
 //BA.debugLineNum = 229;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 231;BA.debugLine="End Sub";
return "";
}
public static String  _lbln_click() throws Exception{
 //BA.debugLineNum = 119;BA.debugLine="Sub lblN_Click";
 //BA.debugLineNum = 120;BA.debugLine="If connected Then													'only apply if connected to a bluetooth device";
if (_connected) { 
 //BA.debugLineNum = 121;BA.debugLine="If N Then														'if the button is ON";
if (_n) { 
 //BA.debugLineNum = 122;BA.debugLine="N = False";
_n = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 123;BA.debugLine="lblN.Color = Colors.Gray";
mostCurrent._lbln.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 124;BA.debugLine="TextWriter1.WriteLine(\"B\")									'write a string to the serial port to switch OFF the corresponding LED";
_textwriter1.WriteLine("B");
 }else {
 //BA.debugLineNum = 126;BA.debugLine="N = True";
_n = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 127;BA.debugLine="lblN.Color = Colors.Red";
mostCurrent._lbln.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 128;BA.debugLine="TextWriter1.WriteLine(\"A\")									'write a string to the serial port to switch ON the corresponding LED";
_textwriter1.WriteLine("A");
 };
 //BA.debugLineNum = 130;BA.debugLine="TextWriter1.Flush												'clear the serialport TX buffer to make sure the previous string gets sent";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 132;BA.debugLine="End Sub";
return "";
}
public static String  _lblne_click() throws Exception{
 //BA.debugLineNum = 204;BA.debugLine="Sub lblNE_Click";
 //BA.debugLineNum = 205;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 206;BA.debugLine="If NE Then";
if (_ne) { 
 //BA.debugLineNum = 207;BA.debugLine="NE = False";
_ne = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 208;BA.debugLine="lblNE.Color = Colors.Gray";
mostCurrent._lblne.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 209;BA.debugLine="TextWriter1.WriteLine(\"D\")";
_textwriter1.WriteLine("D");
 }else {
 //BA.debugLineNum = 211;BA.debugLine="NE = True";
_ne = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 212;BA.debugLine="lblNE.Color = Colors.RGB(255,128,0)	'orange";
mostCurrent._lblne.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 //BA.debugLineNum = 213;BA.debugLine="TextWriter1.WriteLine(\"C\")";
_textwriter1.WriteLine("C");
 };
 //BA.debugLineNum = 215;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 217;BA.debugLine="End Sub";
return "";
}
public static String  _lblnw_click() throws Exception{
 //BA.debugLineNum = 190;BA.debugLine="Sub lblNW_Click";
 //BA.debugLineNum = 191;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 192;BA.debugLine="If NW Then";
if (_nw) { 
 //BA.debugLineNum = 193;BA.debugLine="NW = False";
_nw = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 194;BA.debugLine="lblNW.Color = Colors.Gray";
mostCurrent._lblnw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 195;BA.debugLine="TextWriter1.WriteLine(\"P\")";
_textwriter1.WriteLine("P");
 }else {
 //BA.debugLineNum = 197;BA.debugLine="NW = True";
_nw = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 198;BA.debugLine="lblNW.Color = Colors.Blue";
mostCurrent._lblnw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 199;BA.debugLine="TextWriter1.WriteLine(\"O\")";
_textwriter1.WriteLine("O");
 };
 //BA.debugLineNum = 201;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 203;BA.debugLine="End Sub";
return "";
}
public static String  _lblreset_click() throws Exception{
 //BA.debugLineNum = 234;BA.debugLine="Sub lblReset_Click";
 //BA.debugLineNum = 235;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 236;BA.debugLine="TextWriter1.WriteLine(\"B\")";
_textwriter1.WriteLine("B");
 //BA.debugLineNum = 237;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 238;BA.debugLine="TextWriter1.WriteLine(\"D\")";
_textwriter1.WriteLine("D");
 //BA.debugLineNum = 239;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 240;BA.debugLine="TextWriter1.WriteLine(\"F\")";
_textwriter1.WriteLine("F");
 //BA.debugLineNum = 241;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 242;BA.debugLine="TextWriter1.WriteLine(\"H\")";
_textwriter1.WriteLine("H");
 //BA.debugLineNum = 243;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 244;BA.debugLine="TextWriter1.WriteLine(\"J\")";
_textwriter1.WriteLine("J");
 //BA.debugLineNum = 245;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 246;BA.debugLine="TextWriter1.WriteLine(\"L\")";
_textwriter1.WriteLine("L");
 //BA.debugLineNum = 247;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 248;BA.debugLine="TextWriter1.WriteLine(\"N\")";
_textwriter1.WriteLine("N");
 //BA.debugLineNum = 249;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 250;BA.debugLine="TextWriter1.WriteLine(\"P\")";
_textwriter1.WriteLine("P");
 //BA.debugLineNum = 251;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 253;BA.debugLine="lblN.Color = Colors.Gray";
mostCurrent._lbln.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 254;BA.debugLine="lblNE.Color = Colors.Gray";
mostCurrent._lblne.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 255;BA.debugLine="lblE.Color = Colors.Gray";
mostCurrent._lble.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 256;BA.debugLine="lblSE.Color = Colors.Gray";
mostCurrent._lblse.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 257;BA.debugLine="lblS.Color = Colors.Gray";
mostCurrent._lbls.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 258;BA.debugLine="lblSW.Color = Colors.Gray";
mostCurrent._lblsw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 259;BA.debugLine="lblW.Color = Colors.Gray";
mostCurrent._lblw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 260;BA.debugLine="lblNW.Color = Colors.Gray";
mostCurrent._lblnw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 262;BA.debugLine="N = False";
_n = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 263;BA.debugLine="NE = False";
_ne = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 264;BA.debugLine="E = False";
_e = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 265;BA.debugLine="SE = False";
_se = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 266;BA.debugLine="S = False";
_s = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 267;BA.debugLine="SW = False";
_sw = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 268;BA.debugLine="W = False";
_w = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 269;BA.debugLine="NW = False";
_nw = anywheresoftware.b4a.keywords.Common.False;
 };
 //BA.debugLineNum = 271;BA.debugLine="End Sub";
return "";
}
public static String  _lblreset_longclick() throws Exception{
 //BA.debugLineNum = 274;BA.debugLine="Sub lblReset_LongClick";
 //BA.debugLineNum = 275;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 276;BA.debugLine="TextWriter1.WriteLine(\"A\")";
_textwriter1.WriteLine("A");
 //BA.debugLineNum = 277;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 278;BA.debugLine="TextWriter1.WriteLine(\"C\")";
_textwriter1.WriteLine("C");
 //BA.debugLineNum = 279;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 280;BA.debugLine="TextWriter1.WriteLine(\"E\")";
_textwriter1.WriteLine("E");
 //BA.debugLineNum = 281;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 282;BA.debugLine="TextWriter1.WriteLine(\"G\")";
_textwriter1.WriteLine("G");
 //BA.debugLineNum = 283;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 284;BA.debugLine="TextWriter1.WriteLine(\"I\")";
_textwriter1.WriteLine("I");
 //BA.debugLineNum = 285;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 286;BA.debugLine="TextWriter1.WriteLine(\"K\")";
_textwriter1.WriteLine("K");
 //BA.debugLineNum = 287;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 288;BA.debugLine="TextWriter1.WriteLine(\"M\")";
_textwriter1.WriteLine("M");
 //BA.debugLineNum = 289;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 290;BA.debugLine="TextWriter1.WriteLine(\"O\")";
_textwriter1.WriteLine("O");
 //BA.debugLineNum = 291;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 //BA.debugLineNum = 293;BA.debugLine="lblN.Color = Colors.Red";
mostCurrent._lbln.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 294;BA.debugLine="lblNE.Color = Colors.RGB(255,128,0)	'orange";
mostCurrent._lblne.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 //BA.debugLineNum = 295;BA.debugLine="lblE.Color = Colors.Green";
mostCurrent._lble.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 296;BA.debugLine="lblSE.Color = Colors.Blue";
mostCurrent._lblse.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 297;BA.debugLine="lblS.Color = Colors.Red";
mostCurrent._lbls.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 298;BA.debugLine="lblSW.Color = Colors.RGB(255,128,0)	'orange";
mostCurrent._lblsw.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 //BA.debugLineNum = 299;BA.debugLine="lblW.Color = Colors.Green";
mostCurrent._lblw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 300;BA.debugLine="lblNW.Color = Colors.Blue";
mostCurrent._lblnw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 302;BA.debugLine="N = True";
_n = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 303;BA.debugLine="NE = True";
_ne = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 304;BA.debugLine="E = True";
_e = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 305;BA.debugLine="SE = True";
_se = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 306;BA.debugLine="S = True";
_s = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 307;BA.debugLine="SW = True";
_sw = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 308;BA.debugLine="W = True";
_w = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 309;BA.debugLine="NW = True";
_nw = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 311;BA.debugLine="End Sub";
return "";
}
public static String  _lbls_click() throws Exception{
 //BA.debugLineNum = 176;BA.debugLine="Sub lblS_Click";
 //BA.debugLineNum = 177;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 178;BA.debugLine="If S Then";
if (_s) { 
 //BA.debugLineNum = 179;BA.debugLine="S = False";
_s = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 180;BA.debugLine="lblS.Color = Colors.Gray";
mostCurrent._lbls.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 181;BA.debugLine="TextWriter1.WriteLine(\"J\")";
_textwriter1.WriteLine("J");
 }else {
 //BA.debugLineNum = 183;BA.debugLine="S = True";
_s = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 184;BA.debugLine="lblS.Color = Colors.Red";
mostCurrent._lbls.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 185;BA.debugLine="TextWriter1.WriteLine(\"I\")";
_textwriter1.WriteLine("I");
 };
 //BA.debugLineNum = 187;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 189;BA.debugLine="End Sub";
return "";
}
public static String  _lblse_click() throws Exception{
 //BA.debugLineNum = 161;BA.debugLine="Sub lblSE_Click";
 //BA.debugLineNum = 162;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 163;BA.debugLine="If SE Then";
if (_se) { 
 //BA.debugLineNum = 164;BA.debugLine="SE = False";
_se = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 165;BA.debugLine="lblSE.Color = Colors.Gray";
mostCurrent._lblse.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 166;BA.debugLine="TextWriter1.WriteLine(\"H\")";
_textwriter1.WriteLine("H");
 }else {
 //BA.debugLineNum = 168;BA.debugLine="SE = True";
_se = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 169;BA.debugLine="lblSE.Color = Colors.Blue";
mostCurrent._lblse.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 170;BA.debugLine="TextWriter1.WriteLine(\"G\")";
_textwriter1.WriteLine("G");
 };
 //BA.debugLineNum = 172;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 175;BA.debugLine="End Sub";
return "";
}
public static String  _lblsw_click() throws Exception{
 //BA.debugLineNum = 147;BA.debugLine="Sub lblSW_Click";
 //BA.debugLineNum = 148;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 149;BA.debugLine="If SW Then";
if (_sw) { 
 //BA.debugLineNum = 150;BA.debugLine="SW = False";
_sw = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 151;BA.debugLine="lblSW.Color = Colors.Gray";
mostCurrent._lblsw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 152;BA.debugLine="TextWriter1.WriteLine(\"L\")";
_textwriter1.WriteLine("L");
 }else {
 //BA.debugLineNum = 154;BA.debugLine="SW = True";
_sw = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 155;BA.debugLine="lblSW.Color = Colors.RGB(255,128,0)  'orange";
mostCurrent._lblsw.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 //BA.debugLineNum = 156;BA.debugLine="TextWriter1.WriteLine(\"K\")";
_textwriter1.WriteLine("K");
 };
 //BA.debugLineNum = 158;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 160;BA.debugLine="End Sub";
return "";
}
public static String  _lblw_click() throws Exception{
 //BA.debugLineNum = 133;BA.debugLine="Sub lblW_Click";
 //BA.debugLineNum = 134;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 135;BA.debugLine="If W Then";
if (_w) { 
 //BA.debugLineNum = 136;BA.debugLine="W = False";
_w = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 137;BA.debugLine="lblW.Color = Colors.Gray";
mostCurrent._lblw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 //BA.debugLineNum = 138;BA.debugLine="TextWriter1.WriteLine(\"N\")";
_textwriter1.WriteLine("N");
 }else {
 //BA.debugLineNum = 140;BA.debugLine="W = True";
_w = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 141;BA.debugLine="lblW.Color = Colors.Green";
mostCurrent._lblw.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 //BA.debugLineNum = 142;BA.debugLine="TextWriter1.WriteLine(\"M\")";
_textwriter1.WriteLine("M");
 };
 //BA.debugLineNum = 144;BA.debugLine="TextWriter1.Flush";
_textwriter1.Flush();
 };
 //BA.debugLineNum = 146;BA.debugLine="End Sub";
return "";
}
public static String  _mnuconnect_click() throws Exception{
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
int _res = 0;
 //BA.debugLineNum = 76;BA.debugLine="Sub mnuConnect_Click";
 //BA.debugLineNum = 77;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 78;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
_paireddevices = _serial1.GetPairedDevices();
 //BA.debugLineNum = 79;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 80;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 81;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final double step50 = 1;
final double limit50 = (int)(_paireddevices.getSize()-1);
for (_i = (int)(0); (step50 > 0 && _i <= limit50) || (step50 < 0 && _i >= limit50); _i += step50) {
 //BA.debugLineNum = 82;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i))";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 84;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 85;BA.debugLine="res = InputList(l, \"Choose device\", -1) 	'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device",(int)(-1),mostCurrent.activityBA);
 //BA.debugLineNum = 86;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 87;BA.debugLine="Serial1.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address";
_serial1.Connect(processBA,String.valueOf(_paireddevices.Get(_l.Get(_res))));
 };
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _mnudisconnect_click() throws Exception{
 //BA.debugLineNum = 105;BA.debugLine="Sub mnuDisconnect_Click";
 //BA.debugLineNum = 106;BA.debugLine="Serial1.Disconnect";
_serial1.Disconnect();
 //BA.debugLineNum = 107;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 108;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim N As Boolean = False";
_n = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 19;BA.debugLine="Dim NE As Boolean = False";
_ne = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 20;BA.debugLine="Dim E As Boolean = False";
_e = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 21;BA.debugLine="Dim SE As Boolean  = False";
_se = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 22;BA.debugLine="Dim S As Boolean = False";
_s = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 23;BA.debugLine="Dim SW As Boolean = False";
_sw = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 24;BA.debugLine="Dim W As Boolean = False";
_w = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 25;BA.debugLine="Dim NW As Boolean = False";
_nw = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 28;BA.debugLine="Dim Serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 29;BA.debugLine="Dim TextReader1 As TextReader";
_textreader1 = new anywheresoftware.b4a.objects.streams.File.TextReaderWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim TextWriter1 As TextWriter";
_textwriter1 = new anywheresoftware.b4a.objects.streams.File.TextWriterWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 32;BA.debugLine="Dim connected As Boolean";
_connected = false;
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 91;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 92;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 93;BA.debugLine="ToastMessageShow(\"Connected successfully\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connected successfully",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 94;BA.debugLine="TextReader1.Initialize(Serial1.InputStream)";
_textreader1.Initialize(_serial1.getInputStream());
 //BA.debugLineNum = 95;BA.debugLine="TextWriter1.Initialize(Serial1.OutputStream)";
_textwriter1.Initialize(_serial1.getOutputStream());
 //BA.debugLineNum = 96;BA.debugLine="Timer1.Enabled = True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 97;BA.debugLine="connected = True";
_connected = anywheresoftware.b4a.keywords.Common.True;
 }else {
 //BA.debugLineNum = 99;BA.debugLine="connected = False";
_connected = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 100;BA.debugLine="Timer1.Enabled = False";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 101;BA.debugLine="Msgbox(LastException.Message, \"Error connecting.\")";
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error connecting.",mostCurrent.activityBA);
 };
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
 //BA.debugLineNum = 110;BA.debugLine="Sub Timer1_Tick";
 //BA.debugLineNum = 111;BA.debugLine="If connected Then";
if (_connected) { 
 //BA.debugLineNum = 112;BA.debugLine="If TextReader1.Ready Then 										'check if there is any data waiting to be read";
if (_textreader1.Ready()) { 
 //BA.debugLineNum = 113;BA.debugLine="txtLog.Text = txtLog.Text & TextReader1.ReadLine & CRLF		'add the incoming message to the txtlog and go to the next line of txtlog";
mostCurrent._txtlog.setText((Object)(mostCurrent._txtlog.getText()+_textreader1.ReadLine()+anywheresoftware.b4a.keywords.Common.CRLF));
 //BA.debugLineNum = 114;BA.debugLine="txtLog.SelectionStart = txtLog.Text.Length					'move to the last character in the txtlog to create \"scrolling\" efect";
mostCurrent._txtlog.setSelectionStart(mostCurrent._txtlog.getText().length());
 };
 };
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return "";
}
}
